#!/usr/bin/env bash
set -euo pipefail

version=22.17.1
arch="$(uname -m)"

case $arch in
    x86_64)
        tarball="node-v$version-linux-x64.tar.xz"
        sha256=ff04bc7c3ed7699ceb708dbaaf3580d899ff8bf67f17114f979e83aa74fc5a49
        ;;

    aarch64)
        tarball="node-v$version-linux-arm64.tar.xz"
        sha256=a5bb879af2fe70e7b5dc5e0bbadecba88e87f45bd8e62c0c57b5c815a4cbbaa6
        ;;
esac

check_version() {
    out="$(node --version)" && [ "$out" = "v$version" ] \
        && [ /usr/local/bin/pnpm -ef /srv/zulip-node/lib/node_modules/corepack/dist/pnpm.js ]
}

if ! check_version 2>/dev/null; then
    set -x
    tmpdir="$(mktemp -d)"
    trap 'rm -r "$tmpdir"' EXIT
    cd "$tmpdir"
    curl -fLO --retry 3 "https://nodejs.org/dist/v$version/$tarball"
    sha256sum -c <<<"$sha256 $tarball"
    rm -rf /srv/zulip-node
    mkdir -p /srv/zulip-node
    tar -xJf "$tarball" --no-same-owner --strip-components=1 -C /srv/zulip-node
    ln -sf /srv/zulip-node/bin/{corepack,node,npm,npx} /usr/local/bin
    COREPACK_DEFAULT_TO_LATEST=0 /usr/local/bin/corepack enable

    # Clean up after previous versions of this script
    rm -rf /srv/zulip-yarn /usr/bin/yarn /usr/local/nvm

    check_version
fi
